'==========================================================================
' NAME: BackupEventLogs.vbs
'
' AUTHOR: Alan Kaplan, VA VISN 6
' DATE  : 9/15/04
'
' COMMENT: Backs up event logs to Access database and clears.  Heart of SLAaB
'==========================================================================
Option Explicit
'*** add remaining records to copy status
'Add parameter for don't backup or clear

' Create Files System Object
dim fso
set fso = CreateObject("Scripting.FileSystemObject")

Dim WshShell
Set wshShell = WScript.CreateObject("WScript.Shell")

If (Not IsCScript()) Then 		'If not CScript, re-run with cscript...
	dim quote, strArgs, i
	quote=chr(34)
	
	For i  = WScript.Arguments.Count -1 to  0 Step -1
		strArgs = WScript.Arguments(i) & Space(1) &  strArgs
	Next
	
	WshShell.Run "CScript.exe " & quote & WScript.ScriptFullName & quote & space(1) & strArgs, 1, true
    WScript.Quit            	'...and stop running as WScript
End If



Dim objSecurityLog
Dim strComputer, strLogFolderPath, strFilename
Dim StartTime, EndTime, tMin, tSec
Dim message, timewritten

Const adOpenStatic = 3
Const adLockOptimistic = 3
Const adParamInput = &H0001

'---- DataTypeEnum Values ----
Const adInteger = 3
Const adDBDate = 133
Const adVarChar = 200
Const adLongVarWChar = 203
Dim myOSver

myOSver = GetMyOSVer

If myOSver > 5.0 Then 
	Dim dateTime
	Set dateTime = CreateObject("WbemScripting.SWbemDateTime")
End If

Dim bLimDate
bLimDate = False

Dim DateToCheck, iDaysToCheck
iDaysToCheck = 0 

Dim oConn, rst
Dim objEvent, bClearDCs, sdomain, DCArray

'get path name, ending in \
Dim scriptpath, strDBpath
scriptpath = Left(Wscript.ScriptFullName, InStrRev(Wscript.ScriptFullName, "\"))
strdbpath = fso.GetParentFolderName(scriptpath) & "\"
Dim bBackupClear
bClearDCs = False

GetArgs

If bLimDate Then 
	DateToCheck = Date - iDaysToCheck
	DateTime.SetVarDate DateToCheck, True
End If 

If bLimDate = False Then 
	Wscript.Echo "Beginning " & strcomputer
Else
	Wscript.Echo "Beginning query of last " & iDaysToCheck & _
	" day(s) on "  & strcomputer & ". Completion percentage not calculated."
End If 	

If bClearDCs = False And bBackupClear = True Then
	DCArray=GetDCs() 'Get list to check against if not clearing DCs
End If 

On Error Resume Next

TempLogSetup

StartTime = Now

EventsToDB 

If bBackupClear = True Then 
	BackupAndClear
Else
	WScript.Echo "Skipping backup and clearing of security Log."
End If 


EndTime = Now
MsgBox  "Elapsed Time in minutes: " & DateDiff("n",StartTime,Endtime),vbokonly + vbinformation,strComputer & " Done"

'******* Functions and Subs **************
Sub EventsToDB
On Error goto 0
	Dim cmd, i, trecords
	i = 1
	trecords = RecordCount

	If trecords = 0 Then
		MsgBox "No Security records on " & strComputer, vbinformation + vbokonly,"No Records Found!"
		Exit Sub 
	End if 

 	Set objSecurityLog = GetObject("winmgmts:" _
     & "{impersonationLevel=impersonate,(Security)}!\\" & _
         strComputer & "\root\cimv2")
         
    If Err <> 0 Then
		MsgBox Err.Description,vbcritical + vbokonly,"Error"
		Exit Sub 
	End If     
        
	Dim colSecurityEvents, fixedtime, strWQL
	WScript.Echo "Connecting to Security Event Log on " & strcomputer & ", please wait ..."
	
	If bLimDate = True Then
		strWQL = "Select * from Win32_NTLogEvent Where logfile = 'Security' and TimeWritten >= '" & DateTime & "'"
	Else
		strWQL = "Select * from Win32_NTLogEvent where logfile = 'Security'"
	End If
	
 	Set colSecurityEvents = objSecurityLog.ExecQuery(strWQL,,48)
	   	Set oConn = CreateObject("ADODB.Connection")	
		oConn.Open "Provider = Microsoft.Jet.OLEDB.4.0; " & _
		        "Data Source = " &  strDBpath & "slaab.mdb" 
	For Each objEvent in colSecurityEvents
		Set cmd = CreateObject("ADODB.Command")
			'This cool ??? syntax from Tim Saunders.
		    With cmd
		        .ActiveConnection = oConn
		        .CommandText = "INSERT INTO EventTable " & _
		        	"([Category], [ComputerName], [EventCode], [LogFile], [Message], [RecordNumber], [TimeWritten], [Type], [User]) " & _
		        	"VALUES (?,?,?,?,?,?,?,?,?)"
		            .Parameters.Append cmd.CreateParameter("Category", adInteger, adParamInput, 2, objEvent.Category)
		            .Parameters.Append cmd.CreateParameter("ComputerName", adVarChar, adParamInput, 50, objEvent.ComputerName)
		            .Parameters.Append cmd.CreateParameter("EventCode", adInteger, adParamInput, 5, objevent.EventCode)
 		            .Parameters.Append cmd.CreateParameter("LogFile", adVarChar, adParamInput, 10, objevent.LogFile)

					 message = Replace(objEvent.message,vbcrlf & vbcrlf,vbcrlf)	' cleanup
					 message = Replace(message,vbtab,Space(5))
 		            .Parameters.Append cmd.CreateParameter("Message", adLongVarWChar, adParamInput, Len(message), message)
 		 
 		            .Parameters.Append cmd.CreateParameter("RecordNumber", adInteger, adParamInput, 10, objevent.RecordNumber)
 		            
					 timewritten = cUTC2Lt(objEvent.TimeWritten) ' convert					 
					 
 		            .Parameters.Append cmd.CreateParameter("TimeWritten", adDBDate, adParamInput, Len(timewritten) , TimeWritten)
 		            .Parameters.Append cmd.CreateParameter("Type", adVarChar, adParamInput, 25, objevent.Type)
 		            .Parameters.Append cmd.CreateParameter("User", adVarChar, adParamInput, 50, objEvent.user)
		            .Execute
		    End With
	     	i = i + 1	  
	     	
	     	If bLimDate = False Then    	
		     	WScript.Echo StrComputer & " Security Log record " &  objEvent.recordnumber & " copied to database, " & _
	    		FormatPercent(((i-1) / trecords),2) & " complete."
			Else
		     	WScript.Echo StrComputer & " Security Log record #" &  objEvent.recordnumber & " copied to database."
			End If 			
			
			Set cmd = Nothing	'Must do this to keep memory managed.
	Next
			oConn.Close
			
			If i -1 = 0 Then 
				MsgBox strcomputer & " has no records found in requested date range", vbinformation + vbokonly,"No Records Found"
			Else
				WScript.Echo vbcrlf & strcomputer & " copy of " & i & " events to database done!" & vbcrlf
			End If 
End Sub


Sub TempLogSetup	
	strFilename = FormatDateTime(Now,2)	'vbshortdate
	strFilename = Replace(strFilename,"/","_")
	strFilename = strComputer & "_" & strFilename & "_SecurityLog.evt"
End Sub

Sub RemoteLogSetup	
	' Create Directory If Doesn't Exists
	If not fso.FolderExists(strLogFolderPath) Then 
		fso.CreateFolder(strLogFolderPath)
	End If 

	strFilename = FormatDateTime(Now,2)	'vbshortdate
	strFilename = Replace(strFilename,"/","_")
	strFilename = strComputer & "_" & strFilename  & "_SecurityLog.evt"
End Sub 

Sub BackupAndClear()
On Error goto 0
    Dim logfile, retval, strBackupFile, colLogBackup
 	Set objSecurityLog = GetObject("winmgmts:" _
     & "{impersonationLevel=impersonate,(Backup, Security)}!\\" & _
         strComputer & "\root\cimv2")
	
	Set colLogBackup = objSecurityLog.ExecQuery _ 
		("select * from Win32_NTEventLogFile where LogfileName='Security'")

	' Backup and clear Security Log File 

	strBackupFile = "c:\" & strFilename
	
	Dim UNCPath 
	UNCPath = "\\" & strComputer & "\c$\" & strFilename
	If fso.FileExists(UNCPath) Then fso.DeleteFile UNCPath,True
	
	For each Logfile in colLogBackup
		WScript.Echo "Beginning temporary backup to " & UNCPath
		WScript.Echo "Security log has " &  logfile.NumberOfRecords & " records" 
		retval = LogFile.BackupEventlog(strBackupFile)
		Select Case retval 
			Case 0 	
				Wscript.Echo "Success backing up to temporary file." 
			Case 8 	
				message = "you do not have the necessary rights."
			Case 183 	
				message = "the temporary backup file, " & UNCPath  & ", already exists."
			Case Else 	
				message = "of unknown error number: " & retval & "."
		End Select
		
		If retval <> 0 Then 
			message =  "Failed to backup or clear security log because " & message
			Failed message
		End If 

		'Good local copy, move to new logfile
		WScript.Echo "Moving " & UNCPath & vbcrlf & vbtab & " to " & strLogFolderPath
		retval = fso.MoveFile(UNCPath, strLogFolderPath)

		If retval <> 0 Then 
			message =  "Failed to copy " & strFilename & " to " & strLogFolderPath
			Failed message
		End If 		
		
		If bBackupClear = True And ((bClearDCs = True) Or (bClearDCs = False And IsDC(strComputer) = False)) Then 
			WScript.Echo "Clearing Log for " & strComputer & " ...."
			retval = LogFile.ClearEventlog()
			If retval <> 0 Then 
				message = "Failed to clear Security Log on " & strComputer
				Failed message
			Else
				WScript.Echo "Cleared Log for " & strComputer				
			End If 
		Else
			WScript.Echo "Security Log not cleared for " & strComputer
		End If
	Next
End Sub

Function cUTC2Lt(WMITime)
	If myOSver > 5.0 Then 
		Dim dateTime
		Set dateTime = CreateObject("WbemScripting.SWbemDateTime")
		dateTime.Value = wmiTime
		cUTC2Lt = dateTime.GetVarDate
	Else 
		'Converts WBEM date/Time token to standard date/Time format
		'This is based on work of Bobby Mailik
		Dim yyyy,mm,dd,hh,mn,ss,ms
		yyyy = Left(WMITime, 4)	'year
		mm = Mid(WMITime, 5, 2)	'month
		dd = Mid(WMITime, 7, 2)	'day
		hh = Mid(WMITime, 9, 2)	'hour
		mn = Mid(WMITime, 11, 2)'minutes
		ss = Mid(WMITime, 13, 2)'Seconds
		'ms = Mid(WMITime, 16, 6)'MicroSeconds!
		cUTC2Lt = cdate(mm & "/" & dd & "/" & yyyy & Space (1) & hh & ":" & mn & ":" & ss)
	End If 
End Function

Function GetDCs()
	Dim root, DCs, controller, strDCName 
	Dim OUArray() 
	dim arrIndex
	On Error Resume Next 
	'Get the ADsPath for the domain to search. 
	Set root = GetObject("LDAP://rootDSE")
	sDomain = root.Get("defaultNamingContext")
	'wscript.echo sdomain
	
	'Get the ADsPath for the domain
	Set DCs = GetObject("LDAP://OU=Domain Controllers,"&sdomain)
	If (Err.Number <> 0) Then
		    MsgBox "Error reading list of domain controllers.", vbcritical + vbokonly, "Error"
	    WScript.Quit
	End If
	On Error goto 0
	
	Arrindex = 0
	'Create Array   
	For Each Controller In DCs
	ReDim preserve OUArray(arrIndex)
		strDCName = Mid(Controller.name,4)
		OUArray(arrIndex) = strDCName
		arrIndex = arrIndex + 1
	Next
	
	GetDcs=OUArray
End Function

Function IsDC(strPC) 'There are better ways to do this.
	On Error Resume Next 
	Dim tArray
	tArray = Filter(DCArray, strPC)
	If ubound(tArray) = 0 Then 
		IsDC = True 
		WScript.Echo strPC & " is a domain Controller"
	Else
		IsDC = False
	End If 
	On Error goto 0 
End Function 

Sub Failed(message)
	MsgBox message, vbcritical + vbokonly, StrComputer & " Failed"
	WScript.Quit
End Sub

Sub GetArgs
	If WScript.Arguments.Named.Exists("PC") Then
		strComputer = WScript.Arguments.Named.Item("PC")
	Else
		strComputer = wshShell.ExpandEnvironmentStrings("%COMPUTERNAME%")
		strComputer = InputBox("Backup Event Logs on what server?","Server Name?",strComputer)
	End If 
	
	If strcomputer = "" Then WScript.Quit
	strComputer = UCase(strComputer)
	
	If WScript.Arguments.Named.Exists("LogPath") Then
		strLogFolderPath = WScript.Arguments.Named.Item("LogPath")
	Else
		strLogFolderPath = "\\Computername\Sharename\"
		strLogFolderPath = InputBox("Backup Event Logs to what share?","Share Name?",strLogFolderPath)
	End If 
	
	If strLogFolderPath = "\\Computername\Sharename\" Then WScript.Quit
	if strLogFolderPath = "" Then WScript.Quit
	
	If Right(strLogFolderPath,1) <> "\" Then 
		strLogFolderPath = strLogFolderPath & "\"
	End If  

	If not fso.FolderExists(strLogFolderPath) Then
		MsgBox "Could not find share " & strLogFolderPath, vbcritical + vbokonly, "Error"
	    WScript.Quit
	End If

	If WScript.Arguments.Named.Exists("BackupPC") Then
		bBackupClear = cbool(WScript.Arguments.Named.Item("BackupPC"))
	Else
		bBackupClear = MsgBox("Backup and Clear Security log for Non-DCs?",vbyesnocancel+vbquestion+vbdefaultbutton2,"DC Clear?")
			If bBackupClear = vbcancel Then WScript.Quit
			If bBackupClear = vbyes Then 
				bBackupClear = True
					Else
				bBackupClear = False
			End If 	
	End If 
	
	If WScript.Arguments.Named.Exists("ClearDC") Then
		bClearDCs = cbool(WScript.Arguments.Named.Item("ClearDC"))
	Else
		If bBackupClear = True then
		bClearDCs = MsgBox("Clear Domain Controllers after backup?",vbyesnocancel+vbquestion+vbdefaultbutton2,"DC Clear?")
			If bClearDCs = vbcancel Then WScript.Quit
			If bClearDCs = vbyes Then 
				bClearDCs = True
					Else
				bClearDCs = False
			End If 	
		End If 
	End If 


	If WScript.Arguments.Named.Exists("Days") Then
		iDaystoCheck = WScript.Arguments.Named.Item("Days")
	Else
		If myOSver > 5.0 Then 
			message = "Limit Backup of Event Logs to how many days.?" & _
			vbcrlf & "(Requires XP.  Use 0 for all)"
			iDaysToCheck  = InputBox(message,"Days to Query",0)
		End If
	End If 
	
	iDaysToCheck = CInt(iDaysToCheck)
	
	If MyOSVer > 5.0 And iDaysToCheck <> 0  Then 
		bLimDate = True
	Else
		WScript.Echo "Date filter requires XP or later."
	End If 
	
End Sub

Function RecordCount
    Dim colLogBackup, logfile
 	Set objSecurityLog = GetObject("winmgmts:" _
     & "{impersonationLevel=impersonate,(Backup, Security)}!\\" & _
         strComputer & "\root\cimv2")
	
	Set colLogBackup = objSecurityLog.ExecQuery _ 
		("select * from Win32_NTEventLogFile where LogfileName='Security'")

	For each Logfile in colLogBackup
		RecordCount = logfile.NumberOfRecords
	Next

	
	Set objSecurityLog = Nothing 
End Function


Function IsCScript()
    If (InStr(UCase(WScript.FullName), "CSCRIPT") <> 0) Then
        IsCScript = True
    Else
        IsCScript = False
    End If
End Function

Function GetMyOSVer()
	Dim objIADS, strMyPC
	strMyPC = wshShell.ExpandEnvironmentStrings("%COMPUTERNAME%")
	Set objIADS = Getobject("WinNT://" & strMyPC & ",computer")
	GetmyOSVer = objIADS.OperatingSystemVersion
End Function